--
-- Copyright (C) 1996 Ada Resource Association (ARA), Columbus, Ohio.
-- Author: Gilles Demailly
--
--
-- Permission to use, copy, modify, and distribute this software and its
-- documentation for any purpose and without fee is hereby granted,
-- provided that the above copyright and authorship notice appear in all
-- copies and that both that copyright notice and this permission notice
-- appear in supporting documentation.
-- 
-- The ARA makes no representations about the suitability of this software
-- for any purpose.  It is provided "as is" without express
-- or implied warranty.
-- 

with Ada.Text_Io;

package body Attribute.Constant_Value is

   use Byte_Utilities;

   procedure Decode (This      : access Constant_Value_Attribute;
                     From_File : in Byte_Utilities.File_Type;
                     Context   : in CP.Acc_CP_Infos) is
   begin
      -- reads the index value
      Read (From_File, This.Index);
   end decode;

   procedure Display (This    : access Constant_Value_Attribute;
                      Context : in CP.Acc_CP_Infos) is
   begin
      -- constant_pool [index] gives the constant value for this field
      CP.Display (Context (This.Index), Context);
   end Display;

end Attribute.Constant_Value;
