--
-- Copyright (C) 1996 Ada Resource Association (ARA), Columbus, Ohio.
-- Author: Gilles Demailly
--
--
-- Permission to use, copy, modify, and distribute this software and its
-- documentation for any purpose and without fee is hereby granted,
-- provided that the above copyright and authorship notice appear in all
-- copies and that both that copyright notice and this permission notice
-- appear in supporting documentation.
-- 
-- The ARA makes no representations about the suitability of this software
-- for any purpose.  It is provided "as is" without express
-- or implied warranty.
-- 

with Ada.Text_Io;

package body Attribute.Local_Variable_Table is

   use Byte_Utilities;
     
   procedure Decode (This      : access Local_Variable_Table_Attribute;
                     From_File : in Byte_Utilities.File_Type;
                     Context   : in CP.Acc_CP_Infos) is
   begin
      -- reads the local variable table length
      Read (From_File, This.Local_Variable_Table_Length);

      if This.Local_Variable_Table_Length > 0 then

         -- table allocation
         This.Local_Variable_Table := new Variable_Infos (1..This.Local_Variable_Table_Length);
         
         -- fills the table with Start_Pc, Length, Name_Index, 
         -- Signature_Index, and slot values
         -----------------------------------------------------
         for I in 1..This.Local_Variable_Table_Length loop
            Read (From_File, This.Local_Variable_Table (I).Start_Pc);
            Read (From_File, This.Local_Variable_Table (I).Length);
            Read (From_File, This.Local_Variable_Table (I).Name_Index);
            Read (From_File, This.Local_Variable_Table (I).Signature_Index);
            Read (From_File, This.Local_Variable_Table (I).Slot);
         end loop;
      else
         This.Local_Variable_Table := null;
      end if;

   end Decode;

   procedure Display (This    : access Local_Variable_Table_Attribute;
                      Context : in CP.Acc_CP_Infos) is
   begin
      -- this procedure is not yet implemented (uncalled)
      Ada.Text_Io.Put_Line
         (" Local Variable Table available");
   end Display;

end Attribute.Local_Variable_Table;
