--
-- Copyright (C) 1996 Ada Resource Association (ARA), Columbus, Ohio.
-- Author: Gilles Demailly
--
--
-- Permission to use, copy, modify, and distribute this software and its
-- documentation for any purpose and without fee is hereby granted,
-- provided that the above copyright and authorship notice appear in all
-- copies and that both that copyright notice and this permission notice
-- appear in supporting documentation.
-- 
-- The ARA makes no representations about the suitability of this software
-- for any purpose.  It is provided "as is" without express
-- or implied warranty.
-- 

with Ada.Text_Io;

package body CP.Classes is

   use Byte_Utilities;

   procedure Decode (From_File : Byte_Utilities.File_Type;
                     Some_Info : access Classes) is
   begin
      Some_Info.Tag := C_Class_Tag;

      -- Reads the class name index
      Read (From_File, Some_Info.Name_Index);
   end Decode;

   procedure Display (Some_Info : access Classes;
                      Context   : in Acc_CP_Infos) is
   begin
      -- Displays the class name
      Display (Context (Some_Info.Name_Index), Context);
   end Display;

   function Is_Class
               (Some_Info : access Classes) return Boolean is
   begin
      return True;
   end Is_Class;
      
   function Print_String
               (Some_Info : access Classes;
                Context   : in Acc_CP_Infos) return String is
   begin
      -- calls the same function on the constant value at Name_Index
      return Print_String
                 (Context (Some_Info.Name_Index),
                  Context);
   end Print_String;

   function Java_Decoded_String
               (Some_Info : access Classes;
                Context   : Acc_CP_Infos;
                Purpose   : Decoding_Purpose) return String is
   begin
      -- calls the same function on the constant value at Name_Index
      return Java_Decoded_String
                (Some_Info => Context (Some_Info.Name_Index),
                 Context   => Context,
                 Purpose   => Purpose);
   end Java_Decoded_String;

end CP.Classes;
