--
-- Copyright (C) 1996 Ada Resource Association (ARA), Columbus, Ohio.
-- Author: Gilles Demailly
--
--
-- Permission to use, copy, modify, and distribute this software and its
-- documentation for any purpose and without fee is hereby granted,
-- provided that the above copyright and authorship notice appear in all
-- copies and that both that copyright notice and this permission notice
-- appear in supporting documentation.
-- 
-- The ARA makes no representations about the suitability of this software
-- for any purpose.  It is provided "as is" without express
-- or implied warranty.
-- 

-- This child package provides the class Integers :
-- a constant pool Integer information is used to represent
-- an Integer_32 constant.
--
-- For more information about Java Class file format check :
--    The Java Virtual Machine Specification
--    (Release 1.0 Beta - Draft - August 21, 1995)

with Basic_Definitions;
use Basic_Definitions;

with Byte_Utilities;

package CP.Integers is

   -- the class Tag value in Java files
   ------------------------------------
   C_Class_Tag : constant Unsigned_8 := 3;

   type Integers is new CP_Info with private;
      
   type Acc_Integers is access all Integers'Class;
   
   -- Decode a Constant Pool information
   -------------------------------------
   procedure Decode (From_File : Byte_Utilities.File_Type;
                     Some_Info : access Integers);

   -- Display a Constant Pool information
   --------------------------------------
   procedure Display (Some_Info : access Integers;
                      Context   : in Acc_CP_Infos);
   
private

   -- adds the integer value
   -------------------------
   type Integers is new CP_Info with
      record
         Integer_Value : Integer_32;
      end record;
      
end CP.Integers;
