--
-- Copyright (C) 1996 Ada Resource Association (ARA), Columbus, Ohio.
-- Author: Gilles Demailly
--
--
-- Permission to use, copy, modify, and distribute this software and its
-- documentation for any purpose and without fee is hereby granted,
-- provided that the above copyright and authorship notice appear in all
-- copies and that both that copyright notice and this permission notice
-- appear in supporting documentation.
-- 
-- The ARA makes no representations about the suitability of this software
-- for any purpose.  It is provided "as is" without express
-- or implied warranty.
-- 

with Ada.Text_Io;

package body CP.Long_Integers is

   use Byte_Utilities;
   
   procedure Decode (From_File : Byte_Utilities.File_Type;
                     Some_Info : access Long_Integers) is
   begin
      Some_Info.Tag := C_Class_Tag;

      -- Reads the Integer value
      Read (From_File, Some_Info.Integer_Value);
   end Decode;

   procedure Display (Some_Info : access Long_Integers;
                      Context   : in Acc_CP_Infos) is
   begin
      -- displays the integer value
      Ada.Text_Io.Put
         (Integer_64'Image (Some_Info.Integer_Value));
   end Display;
   
   function Use_Two_Indexes_In_Table
               (Some_Info : access Long_Integers) return Boolean is
   begin
      return True;
   end Use_Two_Indexes_In_Table;
   
end CP.Long_Integers;
