with Ada.Text_Io;

package body CP.Name_And_Type is

   use Byte_Utilities;
   
   procedure Decode (From_File : Byte_Utilities.File_Type;
                     Some_Info : access Name_And_Type) is
   begin
      Some_Info.Tag := C_Class_Tag;

      -- Reads the variable, constant or method index name
      Read (From_File, Some_Info.Name_Index);
      
      -- Reads the signature index
      Read (From_File, Some_Info.Signature_Index);
   end Decode;

   procedure Display (Some_Info : access Name_And_Type;
                      Context   : in Acc_CP_Infos) is
   begin
      -- displays the variable, constant or method name
      -- and the object signature
      -- (gets the names in the Constant Pool)
      Ada.Text_Io.Put 
         (Print_String
             (Context (Some_Info.Name_Index), Context) & " " &
          Java_Decoded_String
             (Context (Some_Info.Signature_Index),
              Context,
              Method_Signature));
   end Display;

  
end CP.Name_And_Type;
