--
-- Copyright (C) 1996 Ada Resource Association (ARA), Columbus, Ohio.
-- Author: Gilles Demailly
--
--
-- Permission to use, copy, modify, and distribute this software and its
-- documentation for any purpose and without fee is hereby granted,
-- provided that the above copyright and authorship notice appear in all
-- copies and that both that copyright notice and this permission notice
-- appear in supporting documentation.
-- 
-- The ARA makes no representations about the suitability of this software
-- for any purpose.  It is provided "as is" without express
-- or implied warranty.
-- 

with Ada.Text_Io;

package body CP.Ref_Info is

   use Byte_Utilities;
   
   procedure Decode (From_File : Byte_Utilities.File_Type;
                     Some_Info : access Ref_Info) is
   begin
      -- should be corrected in the future
      Some_Info.Tag := C_Class_Tag;
      
      -- reads class and Name_And_Type indexes in the Constant Pool
      Read (From_File, Some_Info.Class_Index);
      Read (From_File, Some_Info.Name_And_Type_Index);
   end Decode;

   procedure Display (Some_Info : access Ref_Info;
                      Context   : Acc_CP_Infos) is
   begin
      -- display the class (or interface) name, the object name
      -- and its signature 
      Ada.Text_Io.Put
         (Java_Decoded_String
             (Context (Some_Info.Class_Index),
              Context, 
              Class_Name) & ".");
      Display (Context (Some_Info.Name_And_Type_Index), Context);
   end Display;
   
end CP.Ref_Info;
