--
-- Copyright (C) 1996 Ada Resource Association (ARA), Columbus, Ohio.
-- Author: Gilles Demailly
--
--
-- Permission to use, copy, modify, and distribute this software and its
-- documentation for any purpose and without fee is hereby granted,
-- provided that the above copyright and authorship notice appear in all
-- copies and that both that copyright notice and this permission notice
-- appear in supporting documentation.
-- 
-- The ARA makes no representations about the suitability of this software
-- for any purpose.  It is provided "as is" without express
-- or implied warranty.
-- 

with Ada.Text_Io;

package body CP.Strings is

   use Byte_Utilities;

   procedure Decode (From_File : Byte_Utilities.File_Type;
                     Some_Info : access Strings) is
   begin
      Some_Info.Tag := C_Class_Tag;
      -- Reads the index of the string in the Constant Pool
      Read (From_File, Some_Info.String_Index);
   end Decode;

   procedure Display (Some_Info : access Strings;
                      Context   : in Acc_CP_Infos) is
   begin
      Ada.Text_Io.Put
         (" String constant :  """);
      -- Displays the string 
      Display (Context (Some_Info.String_Index), Context);
      Ada.Text_Io.Put ("""");
   end Display;
   
end CP.Strings;
