--
-- Copyright (C) 1996 Ada Resource Association (ARA), Columbus, Ohio.
-- Author: Gilles Demailly
--
--
-- Permission to use, copy, modify, and distribute this software and its
-- documentation for any purpose and without fee is hereby granted,
-- provided that the above copyright and authorship notice appear in all
-- copies and that both that copyright notice and this permission notice
-- appear in supporting documentation.
-- 
-- The ARA makes no representations about the suitability of this software
-- for any purpose.  It is provided "as is" without express
-- or implied warranty.
-- 

-- This child package provides the class Classes :
-- a constant pool Unicode information is used to represent a String
-- coded with the Unicode Standard.
--
-- For more information about Java Class file format check :
--    The Java Virtual Machine Specification
--    (Release 1.0 Beta - Draft - August 21, 1995)

--
-- WARNING : THIS PACKAGE IS NOT FULLY IMPLEMENTED
-- (USUALLY UTF8 STRINGS ARE USED IN JAVA CLASS FILES)
--

with Basic_Definitions;
use Basic_Definitions;

with Byte_Utilities;

package CP.Unicode is

   -- the class Tag value in Java files
   ------------------------------------
   C_Class_Tag : constant Unsigned_8 := 2;

   type Unicode is new CP_Info with private;
      
   type Acc_Unicode is access all Unicode'Class;
   
   -- Decode a Constant Pool information
   -------------------------------------
   procedure Decode (From_File : Byte_Utilities.File_Type;
                     Some_Info : access Unicode);

   -- Display a Constant Pool information
   --------------------------------------
   procedure Display (Some_Info : access Unicode;
                      Context   : in Acc_CP_Infos);

private

   -- the Unicode String is currently coded as an array of Bytes
   -------------------------------------------------------------
   type Unicode is new CP_Info with
      record
         Length : Unsigned_16;
         bytes  : Byte_Utilities.Acc_Bytes;
      end record;
      
end CP.Unicode;
