--
-- Copyright (C) 1996 Ada Resource Association (ARA), Columbus, Ohio.
-- Author: Gilles Demailly
--
--
-- Permission to use, copy, modify, and distribute this software and its
-- documentation for any purpose and without fee is hereby granted,
-- provided that the above copyright and authorship notice appear in all
-- copies and that both that copyright notice and this permission notice
-- appear in supporting documentation.
-- 
-- The ARA makes no representations about the suitability of this software
-- for any purpose.  It is provided "as is" without express
-- or implied warranty.
-- 

-- This child package provides the class Method_Info :
--  this subclass of Field_Info just overwrittes few methods for
--  Methods.
--
-- For more information about Java Class file format check :
--    The Java Virtual Machine Specification
--    (Release 1.0 Beta - Draft - August 21, 1995)

with Basic_Definitions;
use Basic_Definitions;

with Byte_Utilities;

with CP;

package Field.Method is
   
   -- type and access type for Method_Info
   ---------------------------------------
   type Method_Info is new Field_Info with private;

   type Acc_Method_Info is access all Method_Info'class;      
   
   -- Read a field from a file
   ---------------------------
   function Read_Field 
               (From_File : Byte_Utilities.File_Type;
                Context   : in CP.Acc_CP_Infos)      
            return Acc_Field_Info;

   -- Display Field information for a Java spec
   --------------------------------------------
   procedure Display_Java_Spec (Infos     : access Method_Info;
                                Context   : in CP.Acc_CP_Infos;
                                For_Class : in Unsigned_16;
                                For_Body  : in Boolean);

   -- Display Field information for an Ada spec
   --------------------------------------------
   procedure Display_Ada_Spec (Infos     : access Method_Info;
                               Context   : in CP.Acc_CP_Infos;
                               For_Class : in Unsigned_16);

   -- Display Field information for a Java body
   --------------------------------------------
   procedure Display_Java_Body (Infos     : access Method_Info;
                                Context   : in CP.Acc_CP_Infos;
                                For_Class : in Unsigned_16);

   -- Display Field information for an Ada body
   --------------------------------------------
   procedure Display_Ada_Body (Infos     : access Method_Info;
                               Context   : in CP.Acc_CP_Infos;
                               For_Class : in Unsigned_16);

private

   -- no extensions
   ----------------
   type Method_Info is new Field_Info with null record;

end Field.Method;
